diff --git a/src/test/modules/test_checksums/t/007_pgbench_standby.pl b/src/test/modules/test_checksums/t/007_pgbench_standby.pl
new file mode 100644
index 00000000000..e8ed152f472
--- /dev/null
+++ b/src/test/modules/test_checksums/t/007_pgbench_standby.pl
@@ -0,0 +1,376 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster,
+# comprising of a primary and a replicated standby, with concurrent activity
+# via pgbench runs
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+if (!$ENV{PG_TEST_EXTRA} || $ENV{PG_TEST_EXTRA} !~ /\bchecksum_extended\b/)
+{
+	plan skip_all => 'Extended checksum tests not enabled';
+}
+
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+my $node_primary_slot = 'physical_slot';
+my $node_primary_backup = 'primary_backup';
+my $node_primary;
+my $node_primary_loglocation = 0;
+my $node_standby_1;
+my $node_standby_1_loglocation = 0;
+
+# The number of full test iterations which will be performed. The exact number
+# of tests performed and the wall time taken is non-deterministic as the test
+# performs a lot of randomized actions, but 5 iterations will be a long test
+# run regardless.
+my $TEST_ITERATIONS = 5;
+
+# Variables which record the current state of the cluster
+my $data_checksum_state = 'off';
+
+my $pgbench_primary = undef;
+my $pgbench_standby = undef;
+
+# Start a pgbench run in the background against the server specified via the
+# port passed as parameter
+sub background_pgbench
+{
+	my ($port, $standby) = @_;
+
+	# Terminate any currently running pgbench process before continuing
+	$pgbench_primary->finish if $pgbench_primary;
+
+	# Randomize the number of pgbench clients a bit (range 1-16)
+	my $clients = 1 + int(rand(15));
+
+	my @cmd = ('pgbench', '-p', $port, '-T', '600', '-c', $clients);
+	# Randomize whether we spawn connections or not
+	push(@cmd, '-C') if (cointoss());
+	# If we run on a standby it needs to be a read-only benchmark
+	push(@cmd, '-S') if ($standby);
+	# Finally add the database name to use
+	push(@cmd, 'postgres');
+
+	$pgbench_primary = IPC::Run::start(
+		\@cmd,
+		'<' => '/dev/null',
+		'>' => '/dev/null',
+		'2>' => '/dev/null',
+		IPC::Run::timer($PostgreSQL::Test::Utils::timeout_default));
+}
+
+# Invert the state of data checksums in the cluster, if data checksums are on
+# then disable them and vice versa. Also performs proper validation of the
+# before and after state.
+sub flip_data_checksums
+{
+	# First, make sure the cluster is in the state we expect it to be
+	test_checksum_state($node_primary, $data_checksum_state);
+	test_checksum_state($node_standby_1, $data_checksum_state);
+
+	if ($data_checksum_state eq 'off')
+	{
+		# Coin-toss to see if we are injecting a retry due to a temptable
+		$node_primary->safe_psql('postgres', 'SELECT dcw_fake_temptable();')
+		  if cointoss();
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before enabling: " . $result . "\n");
+
+		# Ensure that the primary switches to "inprogress-on"
+		enable_data_checksums($node_primary, wait => 'inprogress-on');
+
+		random_sleep();
+
+		# Wait for checksum enable to be replayed
+		$node_primary->wait_for_catchup($node_standby_1, 'replay');
+
+		# Ensure that the standby has switched to "inprogress-on" or "on".
+		# Normally it would be "inprogress-on", but it is theoretically
+		# possible for the primary to complete the checksum enabling *and* have
+		# the standby replay that record before we reach the check below.
+		$result = $node_standby_1->poll_query_until(
+			'postgres',
+			"SELECT setting = 'off' "
+			  . "FROM pg_catalog.pg_settings "
+			  . "WHERE name = 'data_checksums';",
+			'f');
+		is($result, 1,
+			'ensure standby has absorbed the inprogress-on barrier');
+		$result = $node_standby_1->safe_psql('postgres',
+				"SELECT setting "
+			  . "FROM pg_catalog.pg_settings "
+			  . "WHERE name = 'data_checksums';");
+
+		is(($result eq 'inprogress-on' || $result eq 'on'),
+			1, 'ensure checksums are on, or in progress, on standby_1');
+
+		# Wait for checksums enabled on the primary and standby
+		wait_for_checksum_state($node_primary, 'on');
+
+		# log LSN right after the primary flips checksums to "on"
+		$result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after enabling: " . $result . "\n");
+
+		random_sleep();
+		wait_for_checksum_state($node_standby_1, 'on');
+
+		$node_primary->safe_psql('postgres',
+			'SELECT dcw_fake_temptable(false);');
+		$data_checksum_state = 'on';
+	}
+	elsif ($data_checksum_state eq 'on')
+	{
+		random_sleep();
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before disabling: " . $result . "\n");
+
+		disable_data_checksums($node_primary);
+		$node_primary->wait_for_catchup($node_standby_1, 'replay');
+
+		# Wait for checksums disabled on the primary and standby
+		wait_for_checksum_state($node_primary, 'off');
+		wait_for_checksum_state($node_standby_1, 'off');
+
+		# log LSN right after the primary flips checksums to "off"
+		$result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after disabling: " . $result . "\n");
+
+		random_sleep();
+		wait_for_checksum_state($node_standby_1, 'off');
+
+		$data_checksum_state = 'off';
+	}
+	else
+	{
+		# This should only happen due to programmer error when hacking on the
+		# test code, but since that might pass subtly we error out.
+		BAIL_OUT('data_checksum_state variable has invalid state:'
+				 . $data_checksum_state);
+	}
+}
+
+# Create and start a cluster with one primary and one standby node, and ensure
+# they are caught up and in sync.
+$node_primary = PostgreSQL::Test::Cluster->new('main');
+$node_primary->init(allows_streaming => 1, no_data_checksums => 1);
+# max_connections need to be bumped in order to accommodate for pgbench clients
+# and log_statement is dialled down since it otherwise will generate enormous
+# amounts of logging. Page verification failures are still logged.
+$node_primary->append_conf(
+	'postgresql.conf',
+	qq[
+max_connections = 30
+log_statement = none
+]);
+$node_primary->start;
+$node_primary->safe_psql('postgres', 'CREATE EXTENSION test_checksums;');
+# Create some content to have un-checksummed data in the cluster
+$node_primary->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1, 100000) AS a;");
+$node_primary->safe_psql('postgres',
+	"SELECT pg_create_physical_replication_slot('$node_primary_slot');");
+$node_primary->backup($node_primary_backup);
+
+$node_standby_1 = PostgreSQL::Test::Cluster->new('standby_1');
+$node_standby_1->init_from_backup($node_primary, $node_primary_backup,
+	has_streaming => 1);
+$node_standby_1->append_conf(
+	'postgresql.conf', qq[
+primary_slot_name = '$node_primary_slot'
+]);
+$node_standby_1->start;
+
+# Initialize pgbench and wait for the objects to be created on the standby
+$node_primary->command_ok([ 'pgbench', '-i', '-s', '100', '-q', 'postgres' ]);
+$node_primary->wait_for_catchup($node_standby_1, 'replay');
+
+# Start the test suite with pgbench running on all nodes
+background_pgbench($node_standby_1->port, 1);
+background_pgbench($node_primary->port, 0);
+
+# Main test suite. This loop will start a pgbench run on the cluster and while
+# that's running flip the state of data checksums concurrently. It will then
+# randomly restart the cluster and then check for
+# the desired state.  The idea behind doing things randomly is to stress out
+# any timing related issues by subjecting the cluster for varied workloads.
+# A TODO is to generate a trace such that any test failure can be traced to
+# its order of operations for debugging.
+for (my $i = 0; $i < $TEST_ITERATIONS; $i++)
+{
+	note("iteration ", ($i + 1), " of ", $TEST_ITERATIONS);
+
+	if (!$node_primary->is_alive)
+	{
+		# start, to do recovery, and stop
+		$node_primary->start;
+		$node_primary->stop('fast');
+
+		# Since the log isn't being written to now, parse the log and check
+		# for instances of checksum verification failures.
+		my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+			$node_primary_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in primary log (during WAL recovery)"
+		);
+		$node_primary_loglocation = -s $node_primary->logfile;
+
+		# randomize the WAL size, to trigger checkpoints less/more often
+		my $sb = 64 + int(rand(960));
+		$node_primary->append_conf('postgresql.conf', qq[max_wal_size = $sb]);
+
+		note("changing primary max_wal_size to " . $sb);
+
+		$node_primary->start;
+
+		# Start a pgbench in the background against the primary
+		background_pgbench($node_primary->port, 0);
+	}
+
+	if (!$node_standby_1->is_alive)
+	{
+		$node_standby_1->start;
+		$node_standby_1->stop('fast');
+
+		# Since the log isn't being written to now, parse the log and check
+		# for instances of checksum verification failures.
+		my $log =
+		  PostgreSQL::Test::Utils::slurp_file($node_standby_1->logfile,
+			$node_standby_1_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in standby_1 log (during WAL recovery)"
+		);
+		$node_standby_1_loglocation = -s $node_standby_1->logfile;
+
+		# randomize the WAL size, to trigger checkpoints less/more often
+		my $sb = 64 + int(rand(960));
+		$node_standby_1->append_conf('postgresql.conf',
+			qq[max_wal_size = $sb]);
+
+		note("changing standby max_wal_size to " . $sb);
+
+		$node_standby_1->start;
+
+		# Start a read-only pgbench in the background on the standby
+		background_pgbench($node_standby_1->port, 1);
+	}
+
+	$node_primary->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+	$node_primary->wait_for_catchup($node_standby_1, 'write');
+
+	flip_data_checksums();
+	random_sleep();
+	my $result = $node_primary->safe_psql('postgres',
+		"SELECT count(*) FROM t WHERE a > 1");
+	is($result, '100000', 'ensure data pages can be read back on primary');
+	random_sleep();
+
+	# Potentially powercycle the cluster (the nodes independently)
+	# XXX should maybe try stopping nodes in the opposite order too?
+	if (cointoss())
+	{
+		$node_primary->stop(stopmode());
+
+		# print the contents of the control file on the primary
+		PostgreSQL::Test::Utils::system_log("pg_controldata",
+			$node_primary->data_dir);
+
+		# slurp the file after shutdown, so that it doesn't interfere with the recovery
+		my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+			$node_primary_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in primary log (outside WAL recovery)"
+		);
+		$node_primary_loglocation = -s $node_primary->logfile;
+	}
+
+	random_sleep();
+
+	if (cointoss())
+	{
+		$node_standby_1->stop(stopmode());
+
+		# print the contents of the control file on the standby
+		PostgreSQL::Test::Utils::system_log("pg_controldata",
+			$node_standby_1->data_dir);
+
+		# slurp the file after shutdown, so that it doesn't interfere with the recovery
+		my $log =
+		  PostgreSQL::Test::Utils::slurp_file($node_standby_1->logfile,
+			$node_standby_1_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed/,
+			"no checksum validation errors in standby_1 log (outside WAL recovery)"
+		);
+		$node_standby_1_loglocation = -s $node_standby_1->logfile;
+	}
+}
+
+# make sure the nodes are running
+if (!$node_primary->is_alive)
+{
+	$node_primary->start;
+}
+
+if (!$node_standby_1->is_alive)
+{
+	$node_standby_1->start;
+}
+
+# Testrun is over, ensure that data reads back as expected and perform a final
+# verification of the data checksum state.
+my $result =
+  $node_primary->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '100000', 'ensure data pages can be read back on primary');
+test_checksum_state($node_primary, $data_checksum_state);
+test_checksum_state($node_standby_1, $data_checksum_state);
+
+# Perform one final pass over the logs and hunt for unexpected errors
+my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+	$node_primary_loglocation);
+unlike(
+	$log,
+	qr/page verification failed/,
+	"no checksum validation errors in primary log");
+$node_primary_loglocation = -s $node_primary->logfile;
+$log = PostgreSQL::Test::Utils::slurp_file($node_standby_1->logfile,
+	$node_standby_1_loglocation);
+unlike(
+	$log,
+	qr/page verification failed/,
+	"no checksum validation errors in standby_1 log");
+$node_standby_1_loglocation = -s $node_standby_1->logfile;
+
+$node_standby_1->teardown_node;
+$node_primary->teardown_node;
+
+done_testing();
diff --git a/src/test/modules/test_checksums/t/DataChecksums/Utils.pm b/src/test/modules/test_checksums/t/DataChecksums/Utils.pm
new file mode 100644
index 00000000000..d299a1ba01d
--- /dev/null
+++ b/src/test/modules/test_checksums/t/DataChecksums/Utils.pm
@@ -0,0 +1,261 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+=pod
+
+=head1 NAME
+
+DataChecksums::Utils - Utility functions for testing data checksums in a running cluster
+
+=head1 SYNOPSIS
+
+  use PostgreSQL::Test::Cluster;
+  use DataChecksums::Utils qw( .. );
+
+  # Create, and start, a new cluster
+  my $node = PostgreSQL::Test::Cluster->new('primary');
+  $node->init;
+  $node->start;
+
+  test_checksum_state($node, 'off');
+
+  enable_data_checksums($node);
+
+  wait_for_checksum_state($node, 'on');
+
+
+=cut
+
+package DataChecksums::Utils;
+
+use strict;
+use warnings FATAL => 'all';
+use Exporter 'import';
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+our @EXPORT = qw(
+  cointoss
+  disable_data_checksums
+  enable_data_checksums
+  random_sleep
+  stopmode
+  test_checksum_state
+  wait_for_checksum_state
+  wait_for_cluster_crash
+);
+
+=pod
+
+=head1 METHODS
+
+=over
+
+=item test_checksum_state(node, state)
+
+Test that the current value of the data checksum GUC in the server running
+at B<node> matches B<state>.  If the values differ, a test failure is logged.
+Returns True if the values match, otherwise False.
+
+=cut
+
+sub test_checksum_state
+{
+	my ($postgresnode, $state) = @_;
+
+	my $result = $postgresnode->safe_psql('postgres',
+		"SELECT setting FROM pg_catalog.pg_settings WHERE name = 'data_checksums';"
+	);
+	is($result, $state, 'ensure checksums are set to ' . $state);
+	return $result eq $state;
+}
+
+=item wait_for_checksum_state(node, state)
+
+Test the value of the data checksum GUC in the server running at B<node>
+repeatedly until it matches B<state> or times out.  Processing will run for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.  If the
+values differ when the process times out, False is returned and a test failure
+is logged, otherwise True.
+
+=cut
+
+sub wait_for_checksum_state
+{
+	my ($postgresnode, $state) = @_;
+
+	my $res = $postgresnode->poll_query_until(
+		'postgres',
+		"SELECT setting FROM pg_catalog.pg_settings WHERE name = 'data_checksums';",
+		$state);
+	is($res, 1, 'ensure data checksums are transitioned to ' . $state);
+	return $res == 1;
+}
+
+=item wait_for_cluster_crash(node, params)
+
+Repeatedly test if the cluster running at B<node> for responds to connections
+and return when it no longer does so, or when it times out.  Processing will
+run for $PostgreSQL::Test::Utils::timeout_default seconds unless a timeout
+value is specified as a parameter.  Returns True if the cluster crashed, else
+False if the process timed out.
+
+=over
+
+=item timeout
+
+Approximate number of seconds to wait for cluster to crash, default is
+$PostgreSQL::Test::Utils::timeout_default.  There are no real-time guarantee
+that the total process time won't exceed the timeout.
+
+=back
+
+=cut
+
+sub wait_for_cluster_crash
+{
+	my $postgresnode = shift;
+	my %params = @_;
+	my $crash = 0;
+
+	$params{timeout} = $PostgreSQL::Test::Utils::timeout_default
+	  unless (defined($params{timeout}));
+
+	for (my $naps = 0; $naps < $params{timeout}; $naps++)
+	{
+		if (!$postgresnode->is_alive)
+		{
+			$crash = 1;
+			last;
+		}
+		sleep(1);
+	}
+
+	return $crash == 1;
+}
+
+=item enable_data_checksums($node, %params)
+
+Function for enabling data checksums in the cluster running at B<node>.
+
+=over
+
+=item cost_delay
+
+The B<cost_delay> to use when enabling data checksums, default is 0.
+
+=item cost_limit
+
+The B<cost_limit> to use when enabling data checksums, default is 100.
+
+=item wait
+
+If defined, the function will wait for the state defined in this parameter,
+waiting timing out, before returning.  The function will wait for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.
+
+=back
+
+=cut
+
+sub enable_data_checksums
+{
+	my $postgresnode = shift;
+	my %params = @_;
+
+	# Set sane defaults for the parameters
+	$params{cost_delay} = 0 unless (defined($params{cost_delay}));
+	$params{cost_limit} = 100 unless (defined($params{cost_limit}));
+
+	my $query = <<'EOQ';
+SELECT pg_enable_data_checksums(%s, %s);
+EOQ
+
+	$postgresnode->safe_psql('postgres',
+		sprintf($query, $params{cost_delay}, $params{cost_limit}));
+
+	wait_for_checksum_state($postgresnode, $params{wait})
+	  if (defined($params{wait}));
+}
+
+=item disable_data_checksums($node, %params)
+
+Function for disabling data checksums in the cluster running at B<node>.
+
+=over
+
+=item wait
+
+If defined, the function will wait for the state to turn to B<off>, or
+waiting timing out, before returning.  The function will wait for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.
+Unlike in C<enable_data_checksums> the value of the parameter is discarded.
+
+=back
+
+=cut
+
+sub disable_data_checksums
+{
+	my $postgresnode = shift;
+	my %params = @_;
+
+	$postgresnode->safe_psql('postgres',
+		'SELECT pg_disable_data_checksums();');
+
+	wait_for_checksum_state($postgresnode, 'off') if (defined($params{wait}));
+}
+
+=item cointoss
+
+Helper for retrieving a binary value with random distribution for deciding
+whether to turn things off during testing.
+
+=back
+
+=cut
+
+sub cointoss
+{
+	return int(rand() < 0.5);
+}
+
+=item random_sleep(max)
+
+Helper for injecting random sleeps here and there in the testrun. The sleep
+duration will be in the range (0,B<max>), but won't be predictable in order to
+avoid sleep patterns that manage to avoid race conditions and timing bugs.
+The default B<max> is 3 seconds.
+
+=back
+
+=cut
+
+sub random_sleep
+{
+	my $max = shift;
+	sleep(int(rand(defined($max) ? $max : 3))) if cointoss;
+}
+
+=item stopmode
+
+Small helper function for randomly selecting a valid stopmode.
+
+=back
+
+=cut
+
+sub stopmode
+{
+	return 'immediate' if (cointoss);
+	return 'fast';
+}
+
+=pod
+
+=back
+
+=cut
+
+1;
diff --git a/src/test/modules/test_checksums/test_checksums--1.0.sql b/src/test/modules/test_checksums/test_checksums--1.0.sql
new file mode 100644
index 00000000000..fb1c802461b
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums--1.0.sql
@@ -0,0 +1,28 @@
+/* src/test/modules/test_checksums/test_checksums--1.0.sql */
+
+-- complain if script is sourced in psql, rather than via CREATE EXTENSION
+\echo Use "CREATE EXTENSION test_checksums" to load this file. \quit
+
+CREATE FUNCTION dcw_inject_delay_barrier(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_launcher_delay(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_startup_delay(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_fail_database(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_prune_dblist(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_fake_temptable(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
diff --git a/src/test/modules/test_checksums/test_checksums.c b/src/test/modules/test_checksums/test_checksums.c
new file mode 100644
index 00000000000..493dc29a1d7
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums.c
@@ -0,0 +1,222 @@
+/*--------------------------------------------------------------------------
+ *
+ * test_checksums.c
+ *		Test data checksums
+ *
+ * Copyright (c) 2026, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *		src/test/modules/test_checksums/test_checksums.c
+ *
+ * -------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "funcapi.h"
+#include "miscadmin.h"
+#include "postmaster/datachecksumsworker.h"
+#include "storage/latch.h"
+#include "utils/injection_point.h"
+#include "utils/wait_event.h"
+
+PG_MODULE_MAGIC;
+
+extern PGDLLEXPORT void dc_delay_barrier(const char *name, const void *private_data, void *arg);
+extern PGDLLEXPORT void dc_fail_database(const char *name, const void *private_data, void *arg);
+extern PGDLLEXPORT void dc_dblist(const char *name, const void *private_data, void *arg);
+extern PGDLLEXPORT void dc_fake_temptable(const char *name, const void *private_data, void *arg);
+
+extern PGDLLEXPORT void crash(const char *name, const void *private_data, void *arg);
+
+/*
+ * Test for delaying emission of procsignalbarriers.
+ */
+void
+dc_delay_barrier(const char *name, const void *private_data, void *arg)
+{
+	(void) name;
+	(void) private_data;
+
+	(void) WaitLatch(MyLatch,
+					 WL_LATCH_SET | WL_TIMEOUT | WL_EXIT_ON_PM_DEATH,
+					 (3 * 1000),
+					 WAIT_EVENT_PG_SLEEP);
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_delay_barrier);
+Datum
+dcw_inject_delay_barrier(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksums-enable-checksums-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksums-enable-checksums-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_launcher_delay);
+Datum
+dcw_inject_launcher_delay(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-launcher-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-launcher-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_startup_delay);
+Datum
+dcw_inject_startup_delay(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-startup-delay",
+							 "test_checksums",
+							 "dc_delay_barrier",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-startup-delay");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+void
+dc_fail_database(const char *name, const void *private_data, void *arg)
+{
+	static bool first_pass = true;
+	DataChecksumsWorkerResult *res = (DataChecksumsWorkerResult *) arg;
+
+	if (first_pass)
+		*res = DATACHECKSUMSWORKER_FAILED;
+	first_pass = false;
+}
+
+PG_FUNCTION_INFO_V1(dcw_inject_fail_database);
+Datum
+dcw_inject_fail_database(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-fail-db",
+							 "test_checksums",
+							 "dc_fail_database",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-fail-db");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+/*
+ * Test to remove an entry from the Databaselist to force re-processing since
+ * not all databases could be processed in the first iteration of the loop.
+ */
+void
+dc_dblist(const char *name, const void *private_data, void *arg)
+{
+	static bool first_pass = true;
+	List	   *DatabaseList = (List *) arg;
+
+	if (first_pass)
+		DatabaseList = list_delete_last(DatabaseList);
+	first_pass = false;
+}
+
+PG_FUNCTION_INFO_V1(dcw_prune_dblist);
+Datum
+dcw_prune_dblist(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-initial-dblist",
+							 "test_checksums",
+							 "dc_dblist",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-initial-dblist");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+/*
+ * Test to force waiting for existing temptables.
+ */
+void
+dc_fake_temptable(const char *name, const void *private_data, void *arg)
+{
+	static bool first_pass = true;
+	int		   *numleft = (int *) arg;
+
+	if (first_pass)
+		*numleft = 1;
+	first_pass = false;
+}
+
+PG_FUNCTION_INFO_V1(dcw_fake_temptable);
+Datum
+dcw_fake_temptable(PG_FUNCTION_ARGS)
+{
+#ifdef USE_INJECTION_POINTS
+	bool		attach = PG_GETARG_BOOL(0);
+
+	if (attach)
+		InjectionPointAttach("datachecksumsworker-fake-temptable-wait",
+							 "test_checksums",
+							 "dc_fake_temptable",
+							 NULL,
+							 0);
+	else
+		InjectionPointDetach("datachecksumsworker-fake-temptable-wait");
+#else
+	elog(ERROR,
+		 "test is not working as intended when injection points are disabled");
+#endif
+	PG_RETURN_VOID();
+}
+
+void
+crash(const char *name, const void *private_data, void *arg)
+{
+	abort();
+}
diff --git a/src/test/modules/test_checksums/test_checksums.control b/src/test/modules/test_checksums/test_checksums.control
new file mode 100644
index 00000000000..84b4cc035a7
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums.control
@@ -0,0 +1,4 @@
+comment = 'Test code for data checksums'
+default_version = '1.0'
+module_pathname = '$libdir/test_checksums'
+relocatable = true
diff --git a/src/test/perl/PostgreSQL/Test/Cluster.pm b/src/test/perl/PostgreSQL/Test/Cluster.pm
index e267ba868fe..8b3c4af3284 100644
--- a/src/test/perl/PostgreSQL/Test/Cluster.pm
+++ b/src/test/perl/PostgreSQL/Test/Cluster.pm
@@ -3863,6 +3863,42 @@ sub advance_wal
 	}
 }
 
+=item $node->checksum_enable_offline()
+
+Enable data page checksums in an offline cluster with B<pg_checksums>. The
+caller is responsible for ensuring that the cluster is in the right state for
+this operation.
+
+=cut
+
+sub checksum_enable_offline
+{
+	my ($self) = @_;
+
+	print "# Enabling checksums in \"$self->data_dir\"\n";
+	PostgreSQL::Test::Utils::system_or_bail('pg_checksums', '-D',
+		$self->data_dir, '-e');
+	return;
+}
+
+=item $node->checksum_disable_offline()
+
+Disable data page checksums in an offline cluster with B<pg_checksums>. The
+caller is responsible for ensuring that the cluster is in the right state for
+this operation.
+
+=cut
+
+sub checksum_disable_offline
+{
+	my ($self) = @_;
+
+	print "# Disabling checksums in \"$self->data_dir\"\n";
+	PostgreSQL::Test::Utils::system_or_bail('pg_checksums', '-D',
+		$self->data_dir, '-d');
+	return;
+}
+
 =pod
 
 =back
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 9f5ee8fd482..f4cce543113 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -428,6 +428,8 @@ CheckPointStmt
 CheckpointStatsData
 CheckpointerRequest
 CheckpointerShmemStruct
+ChecksumBarrierCondition
+ChecksumType
 Chromosome
 CkptSortItem
 CkptTsStatus
@@ -598,6 +600,7 @@ CustomScan
 CustomScanMethods
 CustomScanState
 CycleCtr
+DataChecksumsWorkerOperation
 DBState
 DCHCacheEntry
 DEADLOCK_INFO
@@ -621,6 +624,10 @@ DataPageDeleteStack
 DataTypesUsageChecks
 DataTypesUsageVersionCheck
 DatabaseInfo
+DataChecksumsWorkerDatabase
+DataChecksumsWorkerResult
+DataChecksumsWorkerResultEntry
+DataChecksumsWorkerShmemStruct
 DateADT
 DateTimeErrorExtra
 Datum
@@ -4314,6 +4321,8 @@ xl_btree_split
 xl_btree_unlink_page
 xl_btree_update
 xl_btree_vacuum
+xl_checkpoint_redo
+xl_checksum_state
 xl_clog_truncate
 xl_commit_ts_truncate
 xl_dbase_create_file_copy_rec
-- 
2.39.3 (Apple Git-146)

